//
//  CellMoveTableViewCell.m
//  Test
//
//  Created by kaiyitech on 2018/9/10.
//  Copyright © 2018年 test. All rights reserved.
//

#import "CellMoveTableViewCell.h"
#import <Masonry.h>

@interface CellMoveTableViewCell()
@property (nonatomic, strong) UILabel *descLabel;
@property (nonatomic, strong) UILabel *leftLabel;
@property (nonatomic, strong) UILabel *middelLabel;
@property (nonatomic, strong) UILabel *rightLabel;
@property (nonatomic, strong) UIView *bgView;
@end

@implementation CellMoveTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (instancetype) initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self){
        [self.bgView mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.equalTo(self).offset(15);
            make.right.equalTo(self).offset(-15);
            make.top.equalTo(self).offset(15);
            make.bottom.equalTo(self).offset(-15);
        }];
        
        [self.descLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.top.right.equalTo(self.bgView);
            make.height.equalTo(@20);
        }];
        
        [self.leftLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.bottom.equalTo(self.bgView);
            make.width.equalTo(@30);
            make.height.equalTo(@20);
        }];
        
        [self.middelLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.bottom.equalTo(self.bgView);
            make.centerX.equalTo(self.bgView);
            make.width.equalTo(@30);
            make.height.equalTo(@20);
        }];
        
        [self.rightLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.right.bottom.equalTo(self.bgView);
            make.width.equalTo(@30);
            make.height.equalTo(@20);
        }];
    }
    return self;
}

- (UIView *)bgView{
    if (!_bgView){
        _bgView = [UIView new];
        self.bgView.backgroundColor = [UIColor grayColor];
        [self addSubview:_bgView];
    }
    return _bgView;
}

- (UILabel *)descLabel{
    if (!_descLabel){
        _descLabel = [UILabel new];
        [self.bgView addSubview:_descLabel];
    }
    return _descLabel;
}

- (UILabel *)leftLabel{
    if (!_leftLabel){
        _leftLabel = [UILabel new];
        _leftLabel.text = @"上";
        _leftLabel.font = [UIFont systemFontOfSize:13];
        [self _tapAction:_leftLabel index:1];
        [self.bgView addSubview:_leftLabel];
    }
    return _leftLabel;
}

- (UILabel *)rightLabel{
    if (!_rightLabel){
        _rightLabel = [UILabel new];
        _rightLabel.text = @"下";
        _rightLabel.font = [UIFont systemFontOfSize:13];
        [self _tapAction:_rightLabel index:3];
        [self.bgView addSubview:_rightLabel];
    }
    return _rightLabel;
}

- (UILabel *)middelLabel{
    if (!_middelLabel){
        _middelLabel = [UILabel new];
        _middelLabel.text = @"删";
        _middelLabel.font = [UIFont systemFontOfSize:13];
        [self _tapAction:_middelLabel index:2];
        [self.bgView addSubview:_middelLabel];
    }
    return _middelLabel;
}

- (void)_tapAction:(UILabel *)label index:(NSInteger)index{
    UITapGestureRecognizer *gest = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(_tapAction:)];
    label.tag = index;
    label.userInteractionEnabled = YES;
    [label addGestureRecognizer:gest];
    
}

- (void)_tapAction:(UITapGestureRecognizer *)gest{
    UILabel *label = (UILabel *)gest.view;
    NSInteger index = label.tag;
    if (self.tapBlock){
        self.tapBlock(index,_indexPath);
    }
}

- (void)setDescTitle:(NSString *)descTitle{
    _descLabel.text = descTitle;
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

}

@end
