//
//  CellMoveViewController.m
//  Test
//
//  Created by kaiyitech on 2018/9/10.
//  Copyright © 2018年 test. All rights reserved.
//

#import "CellMoveViewController.h"
#import "CellMoveTableViewCell.h"

@interface CellMoveViewController ()<UITableViewDelegate,UITableViewDataSource>

@end

@implementation CellMoveViewController{
    NSMutableArray *titleArray;
    NSMutableArray *heightArray;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    titleArray = @[@"title1",@"title2",@"title3",@"title4",@"title5",@"title6",@"title7",@"title8",@"title9",@"title10",@"title11",@"title12",@"title13",@"title14",@"title15",@"title16",@"title17"].mutableCopy;
    
    heightArray = @[@160,@150,@140,@170,@160,@190,@150,@160,@150,@140,@170,@160,@190,@150,@160,@150,@140].mutableCopy;
    self.tableView.frame = self.view.bounds;
    
}

- (NSInteger) tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return titleArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    CellMoveTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"CellMoveTableViewCell" forIndexPath:indexPath];
    cell.indexPath = indexPath;
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    cell.tapBlock = ^(NSInteger index, NSIndexPath *path) {
        [self _tapAction:index indexPath:path];
    };
    cell.descTitle = titleArray[indexPath.row];
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return [heightArray[indexPath.row] floatValue];
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
}

- (UITableView *)tableView{
    if (!_tableView){
        _tableView = [[UITableView alloc] initWithFrame:CGRectZero style:UITableViewStylePlain] ;
        _tableView.showsHorizontalScrollIndicator = NO;
        _tableView.showsVerticalScrollIndicator = NO;
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
        [_tableView registerClass:[CellMoveTableViewCell class] forCellReuseIdentifier:NSStringFromClass([CellMoveTableViewCell class])];
        [self.view addSubview:_tableView];
    }
    return _tableView;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)_tapAction:(NSInteger )index indexPath:(NSIndexPath *)indexPath{
    if (index == 2){
        //删除
        [titleArray removeObjectAtIndex:indexPath.row];
        [self.tableView reloadData];
    }else{
        if (index == 1){
            if (indexPath.row > 0){
                UITableViewCell *cell = [_tableView cellForRowAtIndexPath:indexPath];
                NSIndexPath *preIndexPath = [NSIndexPath indexPathForRow:indexPath.row-1 inSection:indexPath.section];
                UITableViewCell *preCell = [_tableView cellForRowAtIndexPath:preIndexPath];
                
                CGFloat preY = preCell.frame.origin.y;
                [UIView animateWithDuration:0.6 animations:^{
                    //当前这个顶部就和上面一个平齐
                    CGRect rect = cell.frame;
                    rect.origin.y = preY;
                    cell.frame = rect;
                    
                    //上面一个需要处理一下,只能基于当前的y+下面的cell的高度,直接交换y轴,位置不准,在刷新表格的时候,会有抖动的现象
                    CGRect rect1 = preCell.frame;
                    rect1.origin.y = preY + CGRectGetHeight(cell.frame);
                    preCell.frame = rect1;
                } completion:^(BOOL finished) {
                    [titleArray exchangeObjectAtIndex:indexPath.row withObjectAtIndex:preIndexPath.row];
                    [heightArray exchangeObjectAtIndex:indexPath.row withObjectAtIndex:preIndexPath.row];
                    [self.tableView reloadData];
                }];
            }
        }else{
            if (indexPath.row < titleArray.count - 1){
                UITableViewCell *cell = [_tableView cellForRowAtIndexPath:indexPath];
                NSIndexPath *nextIndexPath = [NSIndexPath indexPathForRow:indexPath.row+1 inSection:indexPath.section];
                UITableViewCell *nextCell = [_tableView cellForRowAtIndexPath:nextIndexPath];
                
                CGFloat cellY = cell.frame.origin.y;
                [UIView animateWithDuration:0.6 animations:^{
                    //当前这个顶部就和上面一个平齐
                    CGRect rect = cell.frame;
                    rect.origin.y = cellY + CGRectGetHeight(nextCell.frame);
                    cell.frame = rect;
                    //上面一个需要处理一下,只能基于当前的y+下面的cell的高度,直接交换y轴,位置不准,在刷新表格的时候,会有抖动的现象
                    CGRect rect1 = nextCell.frame;
                    rect1.origin.y = cellY;
                    nextCell.frame = rect1;
                } completion:^(BOOL finished) {
                    [titleArray exchangeObjectAtIndex:indexPath.row withObjectAtIndex:nextIndexPath.row];
                    [heightArray exchangeObjectAtIndex:indexPath.row withObjectAtIndex:nextIndexPath.row];
                    [self.tableView reloadData];
                }];
            }
        }
    }
}


@end
